/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.impl.database;

import database.connection.ConnectionFactory;
import domain.Invoice;
import domain.InvoiceItem;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Date;
import storage.StorageInvoice;

/**
 *
 * @author student1
 */
public class StorageDatabaseInvoice implements StorageInvoice {

    @Override
    public Invoice save(Invoice invoice) throws Exception {
        Connection connection = ConnectionFactory.getInstance().getConnection();
        String query = "INSERT INTO invoice (created_date, amount) VALUES (?,?)";

        PreparedStatement preparedStatement = connection.prepareStatement(query, Statement.RETURN_GENERATED_KEYS);
        preparedStatement.setDate(1, new java.sql.Date(invoice.getCreatedDate().getTime()));
        preparedStatement.setBigDecimal(2, invoice.getAmount());
        preparedStatement.executeUpdate();
        ResultSet resultSet = preparedStatement.getGeneratedKeys();
        if (resultSet.next()) {
            Long invoiceID = resultSet.getLong(1);
            invoice.setId(invoiceID);
            query = "INSERT INTO invoice_item VALUES (?,?,?,?,?)";
            preparedStatement = connection.prepareStatement(query);
            for (InvoiceItem item : invoice.getItems()) {
                preparedStatement.setLong(1, invoice.getId());
                preparedStatement.setLong(2, item.getOrderNo());
                preparedStatement.setLong(3, item.getProduct().getId());
                preparedStatement.setBigDecimal(4, item.getPrice());
                preparedStatement.setBigDecimal(5, item.getQuantity());

                preparedStatement.executeUpdate();
            }
            connection.commit();//TODO: promeniti upraljanje transakcijama u servisu
        } else {
            connection.rollback();
            throw new Exception("Invoice key is not created."); //TODO lepsa poruka
        }
        return invoice;
    }

}
