/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.impl.database;

import database.connection.ConnectionFactory;
import domain.Manufacturer;
import domain.MeasurementUnit;
import domain.Product;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import storage.StorageProduct;

/**
 *
 * @author student1
 */
public class StorageDatabaseProduct implements StorageProduct {

    @Override
    public Product save(Product product) throws Exception {
        Connection connection = ConnectionFactory.getInstance().getConnection();
        String query = "INSERT INTO product (name,description,id_manufacturer,price,measurement_unit) VALUES(?,?,?,?,?)";

        PreparedStatement preparedStatement = connection.prepareStatement(query, Statement.RETURN_GENERATED_KEYS);
        preparedStatement.setString(1, product.getName());
        preparedStatement.setString(2, product.getDescription());
        preparedStatement.setLong(3, product.getManufacturer().getId());
        preparedStatement.setBigDecimal(4, product.getPrice());
        preparedStatement.setString(5, String.valueOf(product.getMeasurementUnit()));
        preparedStatement.executeUpdate();

        // uzmi generisan id:
        ResultSet rs = preparedStatement.getGeneratedKeys();
        if (rs.next()) {
            Long id = rs.getLong(1);
            product.setId(id);
        } // else { kljuc nije generisan  }
        connection.commit();//TODO: promeniti upravljanje transakcijama u servisu
        preparedStatement.close();
        return product;
    }

    @Override
    public List<Product> findAll() throws Exception {
        List<Product> products = new ArrayList<>();
        try {
            Connection connection = ConnectionFactory.getInstance().getConnection();
            String query = "SELECT p.id, p.name, p.description, p.measurement_unit, p.price, m.id AS manufacturer_id, m.name AS manufacturer "
                    + "FROM product p INNER JOIN manufacturer m ON p.id_manufacturer = m.id";
            Statement statement = connection.createStatement();
            ResultSet resultSet = statement.executeQuery(query);

            while (resultSet.next()) {
                Long id = resultSet.getLong("id");
                String productName = resultSet.getString("name");
                String description = resultSet.getString("description");
                MeasurementUnit measurementUnit = MeasurementUnit.valueOf(resultSet.getString("measurement_unit"));
                BigDecimal price = resultSet.getBigDecimal("price");

                Long manufacturerId = resultSet.getLong("manufacturer_id");
                String manufacturerName = resultSet.getString("manufacturer");
                Manufacturer manufacturer = new Manufacturer(manufacturerId, manufacturerName);

                Product product = new Product();
                product.setId(id);
                product.setName(productName);
                product.setDescription(description);
                product.setMeasurementUnit(measurementUnit);
                product.setPrice(price);
                product.setManufacturer(manufacturer);

                products.add(product);
            }
            resultSet.close();
            statement.close();

            return products;
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        }
        return products;
    }

}
